VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "OutGauge Test"
   ClientHeight    =   2415
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5415
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   5415
   StartUpPosition =   2  'CenterScreen
   Begin OutGaugeTest.okSocket theSocket 
      Left            =   120
      Top             =   120
      _extentx        =   450
      _extenty        =   423
   End
   Begin VB.Label lblSpeed 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "(speed) mph @ (RPM) RPM"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   20.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   960
      Width           =   4935
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'This can be controlled by 5 lines in the cfg.txt file :
'OutGauge Mode 0        :0-off 1-driving 2-driving+replay
'OutGauge Delay 1       :minimum delay between packets (100ths of a sec)
'OutGauge IP 0.0.0.0    :IP address to send the UDP packet
'OutGauge Port 0        :IP port
'OutGauge ID 0          :if not zero, adds an identifier to the packet

'Each update sends the following UDP packet :
Private Type OutGaugePacket
    Time(0 To 3) As Byte        'unsigned int    Time;           // time in milliseconds (to check order)
    Car(0 To 3) As Byte         'char            Car[4];         // Car name
    Flags(0 To 1) As Byte       'word            Flags;          // Combination of OG_FLAGS, see below
    Gear As Byte                'byte            Gear;           // Reverse:0, Neutral:1, First:2...
    SpareB As Byte              'byte            SpareB;
    Speed As Single             'float           Speed;          // M/S
    RPM As Single               'float           RPM;            // RPM
    Turbo As Single             'float           Turbo;          // BAR
    EngTemp As Single           'float           EngTemp;        // C
    Fuel As Single              'float           Fuel;           // 0 to 1
    OilPress As Single          'float           OilPress;       // BAR
    Spare1 As Single            'float           Spare1;
    Spare2 As Single            'float           Spare2;
    Spare3 As Single            'float           Spare3;
    Throttle As Single          'float           Throttle;       // 0 to 1
    Brake As Single             'float           Brake;          // 0 to 1
    Clutch As Single            'float           Clutch;         // 0 to 1
    Display1(0 To 15) As Byte   'char            Display1[16];   // Usually Fuel
    Display2(0 To 15) As Byte   'char            Display2[16];   // Usually Settings
    ID As Long                  'int             ID;             // (optional ID - if specified in cfg.txt)
End Type

Private Const OG_SHIFTLIGHT As Long = 1  '#define OG_SHIFTLIGHT   1
Private Const OG_FULLBEAM As Long = 2    '#define OG_FULLBEAM     2
Private Const OG_HANDBRAKE As Long = 4   '#define OG_HANDBRAKE    4
Private Const OG_PITSPEED As Long = 8    '#define OG_PITSPEED     8
Private Const OG_TC As Long = 16         '#define OG_TC           16
Private Const OG_HEADLIGHTS As Long = 32 '#define OG_HEADLIGHTS   32
Private Const OG_SIGNAL_L As Long = 64   '#define OG_SIGNAL_L     64
Private Const OG_SIGNAL_R As Long = 128  '#define OG_SIGNAL_R     128
Private Const OG_REDLINE As Long = 256   '#define OG_REDLINE      256
Private Const OG_OILWARN As Long = 512   '#define OG_OILWARN      512
Private Const OG_1 As Long = 1024        '#define OG_1            1024
Private Const OG_2 As Long = 2048        '#define OG_2            2048
Private Const OG_3 As Long = 4096        '#define OG_3            4096
Private Const OG_4 As Long = 8192        '#define OG_4            8192
Private Const OG_KM As Long = 16384      '#define OG_KM           16384
Private Const OG_BAR As Long = 32768     '#define OG_BAR          32768

Private lngTheSocket As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Private Sub Form_Load()
    If theSocket.Initilize("MrOutGauge") Then
        lngTheSocket = theSocket.ListenTo("UDP", 55)
        
        Print "Listening on port 55"
    Else
        Print "Could not initlize winsock!?"
    End If
End Sub

Private Sub theSocket_Received(lngSocket As Long, Data() As Byte)
    If lngSocket = lngTheSocket Then
        Dim Packet As OutGaugePacket
        
        CopyMemory Packet, Data(0), LenB(Packet)
        
        'm/s to mph.. for kph, use 3.6
        lblSpeed.Caption = Format(Packet.Speed * 2.23693629, "##0") & " mph @ " & _
                           Format(Packet.RPM, "####0") & " RPM"
    End If
End Sub
